import {
    listURL,
    debugNetwork, searchURL
} from './lib.js';
import {
    abortOnHidden
} from './abortOnHidden.js';

export default ((document) => {
    return async (showDiv, button) => {
        abortOnHidden(showDiv, button);

        const URLToElement = {};
        listURL.map((url) => { // 保持显示时的顺序性
            const subDiv = document.createElement('div');
            showDiv.appendChild(subDiv);
            URLToElement[url] = subDiv;
        });
        await Promise.all(listURL.map(url => fetch(url, { cache: 'no-store' })
            .then(res => res.json())
            .then(json => requestAnimationFrame(() => { URLToElement[url].innerText = searchURL(json).join('\n'); }))
            .catch(err => debugNetwork(false, url, err))));
    }
})(document);