import {
    listURL,
    debugNetwork
} from './lib.js';
import {
    abortOnHidden
} from './abortOnHidden.js';

export default ((document) => {
    return async (showDiv, button) => {
        abortOnHidden(showDiv, button);
        document.createElement('div').addEventListener('click',)
        document.createElement('div').removeEventListener('click');

        showDiv.style = 'text-align:center;margin:0 auto';

        const inp = document.createElement('input');
        inp.style = 'width:50%';
        inp.placeholder = '可以填写文件名、哈希值等';
        inp.autofocus = true;
        inp.autocomplete = 'off';
        showDiv.appendChild(inp);

        const outp = document.createElement('p');
        showDiv.appendChild(outp);

        const stringList = await Promise.all(listURL.map(url => fetch(url, { cache: 'no-store' })
            .then(res => res.text())
            .catch(err => debugNetwork(false, url, err))));
        const keyValue = {}
        for (let i = 0; i < listURL.length; ++i) {
            keyValue[listURL[i]] = stringList[i] || '';
        }

        inp.addEventListener('input', () => {
            outp.innerText = '查找中...';
            const keyword = inp.value;
            const search = (param) => {
                if (param === '') {
                    return undefined;
                } else {
                    const result = [];
                    for (const key of Object.keys(keyValue)) {
                        if (keyValue[key].includes(param)) {
                            result.push(key);
                        }
                    }
                    return result.length ? result : undefined;
                }
            };
            const result = search(keyword);
            if (result) {
                outp.innerText = `关键词 ${keyword} 在以下 ${result.length} 个文件中出现\n${result.join('\n')}`;
            } else {
                outp.innerText = `未找到关键词 ${keyword}`;
            }
        });
    };
})(document);