import {
    choice, value, createBlobURL,
    isWebpSupported, listURL,
    debugNetwork, debugCache
} from './lib.js';

const imgListCache = {};
const createdBlob = {};

export const getImgBlobURL = async () => {
    const getImgList = async (url) => {
        if (url in imgListCache) {
            debugCache(true, url);
            return imgListCache[url];
        } else {
            debugCache(false, url);
            const res = await fetch(url, { cache: 'force-cache' })
                .then(res => res.json())
                .catch(err => debugNetwork(false, url, err));
            if (res) {
                debugNetwork(true, url);
                imgListCache[url] = res;
                return imgListCache[url];
            } else {
                return value(imgListCache);
            }
        }
    };
    const getImg = async (url) => {
        if (url === undefined) {
            return undefined;
        } else {
            if (url in createdBlob) {
                debugCache(true, url);
                return createdBlob[url];
            } else {
                debugCache(false, url);
                const res = await fetch(url, { cache: 'force-cache' })
                    .then(res => res.blob())
                    .catch(err => debugNetwork(false, url, err));
                if (res) {
                    debugNetwork(true, url);
                    return createBlobURL(res, url, createdBlob);
                } else {
                    return value(createdBlob);
                }
            }
        }
    };
    const imgList = await getImgList(choice(listURL));
    if (!imgList) {
        return undefined;
    } else {
        const img = choice(imgList),
            imgURL = isWebpSupported && img.webp ? img.webp : img.fallback;
        if (!imgURL) {
            return undefined;
        } else {
            return await getImg(imgURL);
        }
    }
};