import json
import os

os.chdir(os.sys.path[0])

version_info = [
    {
        'package': '4a0ca042',
        'version': {
            0: {
                0: [1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 20],
                1: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
            }
        },
        'file': 'loadBackground/imageList.json'
    },
    {
        'package': 'ispcdn',
        'version': {
            0: {
                0: ['0-fix-0', 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, '12-fix-1', 13, 14, 15, 16, 31],
                1: [0, 1, 2, 3, '7-fix-0', 8, 9, 10, '11-fix-0', 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 26, 28, 29, 30, 31],
                2: [0, 1, 2, '6-fix-0']
            }
        },
        'file': 'imgList.json'
    }
]


def process(info):
    package_name = info['package']
    compressed_version = info['version']
    file = info['file']
    full_version = []
    queue = []

    def recursion(obj):
        if isinstance(obj, dict):
            for k, v in obj.items():
                queue.append(str(k))
                recursion(v)
                queue.pop()
        elif isinstance(obj, list):
            for v in obj:
                recursion(v)
        else:
            queue.append(str(obj))
            full_version.append('.'.join(queue))
            queue.pop()

    recursion(compressed_version)
    result = []
    for version in full_version:
        result.append(f'{package_name}@{version}/{file}')
    return result


output = []
for info in version_info:
    output.extend(process(info))

with open('fullList.json', 'w') as fout:
    json.dump(output, fout, indent=4)
