import hashlib
import os
import time
from urllib.parse import urlsplit

import requests

output_dir = input('Output dir: \n')

keyword = 'cat'
url = 'https://source.unsplash.com/featured/?' + keyword
headers = {
    'Referer': 'https://www.npmjs.com/package/isplib',
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36',
}
session = requests.sessions.Session()

while True:
    resp_headers = session.head(
        url, headers=headers, allow_redirects=False).headers
    if not 'Location' in resp_headers:
        raise Exception('Location not found')
    real_url = resp_headers['Location'].split('?', 1)[0]
    print(real_url)

    resp = session.get(real_url, headers=headers)
    resp_headers = resp.headers
    if not 'Content-Type' in resp_headers:
        raise Exception('Content-Type not found')
    content_type = resp_headers['Content-Type']
    if not content_type.startswith('image/'):
        raise Exception('Content-Type not recognized')

    file_type = content_type[6:]
    content = resp.content
    content_hash = hashlib.sha256(content).hexdigest()
    output_path = os.path.join(output_dir, content_hash + '.' + file_type)
    with open(output_path, 'wb') as fout:
        fout.write(content)
    print(output_path)
