import asyncio
import aiohttp
import sys
import os

os.chdir(sys.path[0])

header = {
    'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/83.0.4103.116 Safari/537.36',
    'dnt': '1',
    'accept': '*/*',
    'sec-fetch-site': 'cross-site',
    'sec-fetch-mode': 'no-cors',
    'sec-fetch-dest': 'script',
    'referer': 'https://www.isab.top/tools/deqrcode.php',
    'accept-encoding': 'gzip, deflate',
    'accept-language': 'zh-CN,zh;q=0.9,en;q=0.8'
}

with open('resource_list.txt', 'r') as f:
    ping_list = f.read().split('\n')


async def fetch_all() -> None:
    conn = aiohttp.TCPConnector(limit=10)

    async def fetch(session: aiohttp.ClientSession, url: str) -> None:
        async with session.get(url) as r:
            if r.status == 200:
                sys.stdout.write(f'[INFO] 成功: URL {url}\n')

    async with aiohttp.ClientSession(headers=header, connector=conn, raise_for_status=True) as session:
        while True:
            tasks = [fetch(session, url) for url in ping_list]
            await asyncio.wait(tasks)
            print('[INFO] 检查完成')
            await asyncio.sleep(15.0)


def main():
    loop = asyncio.get_event_loop()
    try:
        loop.run_until_complete(fetch_all())
    except KeyboardInterrupt:
        return
    except Exception as err:
        print(f'[ERROR] 出现错误: {err}')
        input()


if __name__ == "__main__":
    main()
